﻿
using System;
using Wisej.Web;

namespace Wisej.PropertyGridCustomEditors
{
	public partial class Page1 : Page
	{
		public Page1()
		{
			InitializeComponent();
		}

		private void Page1_Load(object sender, EventArgs e)
		{
			this.propertyGrid1.SelectedObject = new DataRecord();
		}

		private void propertyGrid1_SelectedGridItemBeginEdit(object sender, SelectedGridItemBeginEditEventArgs e)
		{
			if (e.GridItem.PropertyDescriptor.Name == "Name")
			{
				e.Editor = GetNameEditor();
				e.Editor.Text = (string)e.GridItem.Value;
			}
		}

		private Control GetNameEditor()
		{
			if (this._nameEditor == null)
			{
				this._nameEditor = new ComboBox();
				this._nameEditor.Items.AddRange(new[] { 
					"Mary",
					"Jack",
					"Bill",
					"Sophia"
				});
			}
			return this._nameEditor;
		}
		private ComboBox _nameEditor;

		private void propertyGrid1_PropertyValueChanged(object sender, PropertyValueChangedEventArgs e)
		{
			this.label1.Text = this.propertyGrid1.SelectedObject.ToJSON();
		}
	}
}
